//+------------------------------------------------------------------+
//|                                                         gaps.mq4 |
//|                                                        SFK Corp. |
//+------------------------------------------------------------------+
#property copyright "SFK Corp."
#property link      ""
//---- input parameters
extern bool       useTimeFilter           = true;
extern int        HourBegin               = 4;
extern int        HourEnd                 = 18;
extern int    min_gapsize = 1;
extern double lotsize_gap = 0.1;
extern double     MaximumRisk       =5;//percentage of account to risk each order
extern double     DecreaseFactor    =3;//lot size reducer during losing streak
extern int    StopLoss=250;
extern int    TakeProfit=250;
//----
datetime order_time=0;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
/* 
 Thing to be done in future in this program to make it more efficient
 and more powerful:
   1. Make the dicission of the quantity of lots used according to 
      the scillators;
   2. This program will catch the gaps.
 Things to ware of:
   1. the spread;
   2. excuting the order not on the gap ends a little bit less.
*/
// Defining the variables to decide.
// Print("order time", order_time);
if(!WorkTime())return 0;
   double current_openprice=iOpen(Symbol(),0,0);
   double previous_highprice= iHigh(Symbol(),0,1);
   double previous_lowprice = iLow(Symbol(),0,1);
   double point_gap=MarketInfo(Symbol(),MODE_POINT);
   int spread_gap=MarketInfo(Symbol(),MODE_SPREAD);
   datetime current_time=iTime(Symbol(),0,0);
   
// catching the gap on sell upper gap
   if(current_openprice>previous_highprice+(min_gapsize+spread_gap)*point_gap && 
      current_time!=order_time)
     {
      int ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,0,
                           //0,
                           Ask+StopLoss*point_gap,
                           Bid-TakeProfit*point_gap,

                           //previous_highprice + spread_gap*point_gap, 
                           "",4,0,clrRed);
      order_time=iTime(Symbol(),0,0);
      Print("I am inside (sell) :-)",order_time);
      //----
      if(ticket<0)
        {
         Print("OrderSend failed with error #",GetLastError());
        }
     }
//catching the gap on buy down gap
   if(current_openprice<previous_lowprice -(min_gapsize+spread_gap)*point_gap && 
      current_time!=order_time)
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,0,
                       //0, 
                       Bid-StopLoss*point_gap,
                       Ask+TakeProfit*point_gap,
                       //previous_lowprice - spread_gap*point_gap,
                       "",5,0,clrGreen);
      order_time=iTime(Symbol(),0,0);
      Print("I am inside (buy) :-)",order_time);
      if(ticket<0)
        {
         Print("OrderSend failed with error #",GetLastError());
        }
     }
//----
   return(0);
  }
//+-----------------------------------
double LotsOptimized(double _sl=0)
  {
   double lot=lotsize_gap;
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double TickVal=MarketInfo(Symbol(),MODE_TICKVALUE);
   int    orders=OrdersHistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int digLots=0;
   if(MinLots<0.1)digLots=2;
   else
      if(MinLots<1)digLots=1;
//--- select lot size
   if(_sl<=0)_sl=iATR(Symbol(),PERIOD_D1,8,1)/Point;
   if(MaximumRisk>0) lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/100/TickVal/_sl,digLots);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor!=0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>=1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,digLots);
     }
//--- return lot size
   return(MathMin(MaxLots,MathMax(MinLots,lot)));
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool WorkTime()
  {
   if(!useTimeFilter) return true;
   int currHour=TimeHour(TimeCurrent());
   if(HourBegin<HourEnd && currHour>=HourBegin && currHour<HourEnd)return true;
   if(HourBegin>=HourEnd && (currHour>=HourBegin || currHour<HourEnd))return true;
   return false;
  }